﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DataTreeNodeConfiguration
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.Loaded += MainWindow_Loaded;
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            A root = new A { Config = "my root", Filters = new List<B>() };
            B foo = new B { Filter = "foo", Items = new List<C>() };
            C solo = new C { Name = "solo" };
            C parent = new C { Name = "parent", Children = new List<C>() };
            C child1 = new C { Name = "child1", Children = new List<C>() };
            C child2 = new C { Name = "child2" };
            C solo2 = new C { Name = "solo2" };

            root.Filters.Add(foo);

            foo.Items.Add(parent);
            foo.Items.Add(child1);
            foo.Items.Add(child2);
            foo.Items.Add(solo);
            foo.Items.Add(solo2);

            parent.Children.Add(child1);
            child1.Parent = parent;

            child1.Children.Add(child2);
            child2.Parent = child1;

            List<A> rootNodes = new List<A>();
            rootNodes.Add(root);
            this.DataContext = rootNodes;
        }
    }

    public class A
    {
        public String Config { get; set; }
        public List<B> Filters { get; set; }
    }
    public class B
    {
        public String Filter { get; set; }
        public List<C> DisplayItems
        {
            get
            {
                return Items.Where(x => x.Parent == null).ToList();
            }
        }
        public List<C> Items { get; set; }
    }
    public class C
    {
        public String Name { get; set; }
        public C Parent { get; set; }
        public List<C> Children { get; set; }
    }

}
